# This file is managed by 'repo_helper'. Don't edit it directly.
---
name: macOS

on:
  push:
    branches-ignore:
      - 'repo-helper-update'
      - 'pre-commit-ci-update-config'
      - 'imgbot'

  pull_request:

permissions:
  actions: write
  contents: read

jobs:
  tests:
    name: "macos-latest / Python ${{ matrix.config.python-version }}"
    runs-on: "macos-latest"
    continue-on-error: ${{ matrix.config.experimental }}
    env:
      USING_COVERAGE: '3.6,3.7,3.8,3.9,3.10,3.11.0-alpha.4,pypy-3.7,pypy-3.8'

    strategy:
      fail-fast: False
      matrix:
        config:
          - {python-version: "3.6", testenvs: "py36-sphinx{3.2,3.3,3.4,3.5,4.0,4.1,4.2,4.3,4.4,latest},build", experimental: False}
          - {python-version: "3.7", testenvs: "py37-sphinx{3.2,3.3,3.4,3.5,4.0,4.1,4.2,4.3,4.4,latest},build", experimental: False}
          - {python-version: "3.8", testenvs: "py38-sphinx{3.2,3.3,3.4,3.5,4.0,4.1,4.2,4.3,4.4,latest},build", experimental: False}
          - {python-version: "3.9", testenvs: "py39-sphinx{3.2,3.3,3.4,3.5,4.0,4.1,4.2,4.3,4.4,latest},build", experimental: False}
          - {python-version: "3.10", testenvs: "py310-sphinx{3.2,3.3,3.4,3.5,4.0,4.1,4.2,4.3,4.4,latest},build", experimental: False}
          - {python-version: "3.11.0-alpha.4", testenvs: "py311-dev-sphinx{3.2,3.3,3.4,3.5,4.0,4.1,4.2,4.3,4.4,latest},build", experimental: True}
          - {python-version: "pypy-3.7", testenvs: "pypy37-sphinx{4.0,4.1,4.2,4.3,4.4,latest},build", experimental: True}
          - {python-version: "pypy-3.8", testenvs: "pypy38-sphinx{4.0,4.1,4.2,4.3,4.4,latest},build", experimental: True}

    steps:
      - name: Checkout 🛎️
        uses: "actions/checkout@v2"

      - name: Check for changed files
        if: startsWith(github.ref, 'refs/tags/') != true
        uses: dorny/paths-filter@v2
        id: changes
        with:
          list-files: "json"
          filters: |
            code:
              - '!(doc-source/**|CONTRIBUTING.rst|.imgbotconfig|.pre-commit-config.yaml|.pylintrc|.readthedocs.yml)'

      - name: Setup Python 🐍
        id: setup-python
        if: ${{ steps.changes.outputs.code == 'true' || steps.changes.outcome == 'skipped' }}
        uses: "actions/setup-python@v2"
        with:
          python-version: "${{ matrix.config.python-version }}"

      - name: Install dependencies 🔧
        if: steps.setup-python.outcome == 'success'
        run: |
          python -VV
          python -m site
          python -m pip install --upgrade pip setuptools wheel
          python -m pip install --upgrade tox virtualenv

      - name: "Run Tests for Python ${{ matrix.config.python-version }}"
        if: steps.setup-python.outcome == 'success'
        run: python -m tox -e "${{ matrix.config.testenvs }}" -s false

      - name: "Upload Coverage 🚀"
        uses: actions/upload-artifact@v2
        if: ${{ always() && steps.setup-python.outcome == 'success' }}
        with:
          name: "coverage-${{ matrix.config.python-version }}"
          path: .coverage
